﻿using System;
using System.Web;
using Dynamicweb.Controls;

namespace Dynamicweb.Samples.Web
{
public class InfoBarSettings
{
/// <summary>
/// Returns the InfoBarSettings instance currently stored in the user' session, or null.
/// </summary>
public static InfoBarSettings Current
{
get
{
return HttpContext.Current.Session["InfoBarSettings"] as InfoBarSettings;
}
}

/// <summary>
/// Removes the InfoBarSettings instance currently stored in the user' session.
/// </summary>
public static void Remove()
{
HttpContext.Current.Session["InfoBarSettings"] = null;
}

/// <summary>
/// Assigns a new InfoBarSettings instance with the supplied message and type and stores it in the user' session.
/// </summary>
public static void CreateMessage(string message, Infobar.MessageType type)
{
InfoBarSettings settings = new InfoBarSettings() { Message = message, Type = type };
HttpContext.Current.Session["InfoBarSettings"] = settings;
}

/// <summary>
/// Gets or sets the message to display in the InfoBar control.
/// </summary>
public string Message { get; set; }

/// <summary>
/// Gets or sets the type of the message to display in the Infobar control.
/// </summary>
public Infobar.MessageType Type { get; set; }
}
}