using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using Dynamicweb;
using System.Data;
using System;

namespace CustomDealersearch
{
	[Serializable()]
	public class Dealer
	{
		private int _ID = 0;
		private int _CategoryID = 0;
		private string _Name = "";
		private string _Adress = "";
		private string _Adress2 = "";
		private string _Zip = "";
		private string _City = "";
		private string _Country = "";
		private string _Description = "";
		private string _Phone1 = "";
		private string _Phone2 = "";
		private string _Fax1 = "";
		private string _Fax2 = "";
		private string _Email = "";
		private string _Website = "";
		private int _Index = 1;
		private Category _Category;

		public int ID
		{
			get { return _ID; }
			set { _ID = value; }
		}
		public int CategoryID
		{
			get { return _CategoryID; }
			set { _CategoryID = value; }
		}
		public string Name
		{
			get { return _Name; }
			set { _Name = value; }
		}

		public string Adress
		{
			get { return _Adress; }
			set { _Adress = value; }
		}
		public string Adress2
		{
			get { return _Adress2; }
			set { _Adress2 = value; }
		}
		public string Zip
		{
			get { return _Zip; }
			set { _Zip = value; }
		}
		public string City
		{
			get { return _City; }
			set { _City = value; }
		}
		public string Country
		{
			get { return _Country; }
			set { _Country = value; }
		}
		public string Description
		{
			get { return _Description; }
			set { _Description = value; }
		}
		public string Phone1
		{
			get { return _Phone1; }
			set { _Phone1 = value; }
		}
		public string Phone2
		{
			get { return _Phone2; }
			set { _Phone2 = value; }
		}
		public string Fax1
		{
			get { return _Fax1; }
			set { _Fax1 = value; }
		}
		public string Fax2
		{
			get { return _Fax2; }
			set { _Fax2 = value; }
		}
		public string Email
		{
			get { return _Email; }
			set { _Email = value; }
		}
		public string Website
		{
			get { return _Website; }
			set { _Website = value; }
		}
		public int Index
		{
			get { return _Index; }
			set { _Index = value; }
		}

		public Category Category
		{
			get
			{
				if (_Category == null)
				{
					_Category = Category.GetCategoryById(this.CategoryID);
				}
				return _Category;
			}
			set { _Category = value; }
		}

		public Dealer()
		{
		}

		public Dealer(int ID)
		{
			using (IDataReader objDataReader = Database.getDataReader("SELECT * FROM DealerSearchDealer WHERE DealerSearchDealerID = " + ID, "DealerSearch.mdb"))
			{
				if (objDataReader.Read())
				{
					Fill(objDataReader);
				}
			}
		}

		public void Fill(IDataReader DataReader)
		{
			_ID = Base.ChkNumber(DataReader["DealerSearchDealerID"]);
			_CategoryID = Base.ChkNumber(DataReader["DealerSearchDealerCategoryID"]);
			_Name = DataReader["DealerSearchDealerName"].ToString();
			_Adress = DataReader["DealerSearchDealerAdress"].ToString();
			_Adress2 = DataReader["DealerSearchDealerAdress2"].ToString();
			_Zip = DataReader["DealerSearchDealerZip"].ToString();
			_City = DataReader["DealerSearchDealerCity"].ToString();
			_Country = DataReader["DealerSearchDealerCountry"].ToString();
			_Description = DataReader["DealerSearchDealerDescription"].ToString();
			_Phone1 = DataReader["DealerSearchDealerPhone1"].ToString();
			_Phone2 = DataReader["DealerSearchDealerPhone2"].ToString();
			_Fax1 = DataReader["DealerSearchDealerFax1"].ToString();
			_Fax2 = DataReader["DealerSearchDealerFax2"].ToString();
			_Email = DataReader["DealerSearchDealerEmail"].ToString();
			_Website = DataReader["DealerSearchDealerWebsite"].ToString();
		}

		public void Save()
		{
			DataSet objDataset = new DataSet();
			DataRow objRow;
			string SQL = "SELECT * FROM DealerSearchDealer WHERE DealerSearchDealerID = " + _ID;
			DataManager DbMan = new DataManager();

			try
			{
				objDataset = DbMan.getDataSet("DealerSearch.mdb", SQL);

				if (_ID != 0)
				{
					objRow = objDataset.Tables[0].Rows[0];
				}
				else
				{
					objRow = objDataset.Tables[0].NewRow();
					objDataset.Tables[0].Rows.Add(objRow);
				}

				objRow["DealerSearchDealerCategoryID"] = _CategoryID;
				objRow["DealerSearchDealerName"] = _Name;
				objRow["DealerSearchDealerAdress"] = _Adress;
				objRow["DealerSearchDealerAdress2"] = _Adress2;
				objRow["DealerSearchDealerZip"] = _Zip;
				objRow["DealerSearchDealerCity"] = _City;
				objRow["DealerSearchDealerCountry"] = _Country;
				objRow["DealerSearchDealerDescription"] = _Description;
				objRow["DealerSearchDealerPhone1"] = _Phone1;
				objRow["DealerSearchDealerPhone2"] = _Phone2;
				objRow["DealerSearchDealerFax1"] = _Fax1;
				objRow["DealerSearchDealerFax2"] = _Fax2;
				objRow["DealerSearchDealerEmail"] = _Email;
				objRow["DealerSearchDealerWebsite"] = _Website;

				DbMan.updateDataSet(objDataset);

				if (_ID == 0)
				{
					_ID = DbMan.getIdentity();
				}
			}
			catch
			{
			}
			finally
			{
				objDataset.Dispose();
				DbMan.Dispose();
			}
		}

		public void Delete()
		{
			if (_ID != 0)
			{
				Delete(_ID);
			}
		}

		public static void Delete(int ID)
		{
			Database.ExecuteNonQuery("DELETE FROM DealerSearchDealer WHERE DealerSearchDealerID = " + ID, "DealerSearch.mdb");
		}

		public Dealer Copy()
		{
			Dealer objDealer = new Dealer();

			objDealer = this.Clone();
			objDealer.ID = 0;
			objDealer.Name = "Copy of " + objDealer.Name;
			objDealer.Save();
			return objDealer;
		}

		public Dealer Clone()
		{
			//This is why the class is serializable.
			MemoryStream memStream = new MemoryStream();
			BinaryFormatter binFormatter = new BinaryFormatter();

			binFormatter.Serialize(memStream, this);
			memStream.Position = 0;
			return (Dealer)binFormatter.Deserialize(memStream);
		}
	}
}
